angular.module('focaModalChofer')
    .controller('focaModalChoferController', 
        [
            '$timeout',
            '$filter',
            '$scope',
            '$uibModalInstance',
            'focaModalChoferService',
            function($timeout, $filter, $scope, $uibModalInstance,
                focaModalChoferService
            ) {

                $scope.filters = '';
                $scope.choferes = [];
                $scope.primerBusqueda = false;
                $scope.searchLoading = false;
                // pagination
                $scope.numPerPage = 10;
                $scope.currentPage = 1;
                $scope.filteredChoferes = [];
                $scope.currentPageChoferes = [];
                $scope.selectedChofer = -1;

                //METODOS
                $scope.busquedaPress = function(key) {
                    if (key === 13) {
                        $scope.searchLoading = true;
                        focaModalChoferService.getChoferes().then(llenarDatos);
                    }
                };
                function llenarDatos(res) {
                    $scope.searchLoading = false;
                    $scope.primerBusqueda = true;
                    $scope.choferes = res.data;
                    $scope.search(true);
                    primera();
                }
                $scope.search = function(pressed) {
                    if($scope.choferes.length > 0) {
                        $scope.filteredChoferes = $filter('filter')(
                            $scope.choferes,
                            {$: $scope.filters}
                        );

                        if(pressed && $scope.filteredChoferes.length === 0){
                            $timeout(function() {
                                angular.element('#search')[0].focus();
                                $scope.filters = '';
                            });
                        }

                        $scope.lastPage = Math.ceil(
                            $scope.filteredChoferes.length / $scope.numPerPage
                        );

                        $scope.resetPage();

                    }
                };

                $scope.resetPage = function() {
                    $scope.currentPage = 1;
                    $scope.selectPage(1);
                };

                $scope.selectPage = function(page) {
                    var start = (page - 1) * $scope.numPerPage;
                    var end = start + $scope.numPerPage;
                    $scope.paginas = [];
                    $scope.paginas = calcularPages(page);
                    $scope.currentPageChoferes =
                        $scope.filteredChoferes.slice(start, end);
                    $scope.currentPage = page;
                };

                $scope.select = function(chofer) {
                    $uibModalInstance.close(chofer);
                };

                $scope.cancel = function() {
                    $uibModalInstance.dismiss('cancel');
                };

                $scope.busquedaDown = function(key) {
                    if (key === 40) {
                        primera(key);
                    }
                };

                $scope.itemChofer = function(key) {
                    if (key === 38) {
                        anterior(key);
                    }

                    if (key === 40) {
                        siguiente(key);
                    }

                    if (key === 37) {
                        retrocederPagina();
                    }

                    if (key === 39) {
                        avanzarPagina();
                    }
                };

                function calcularPages(paginaActual) {
                    var paginas = [];
                    paginas.push(paginaActual);

                    if (paginaActual - 1 > 1) {
                        
                        paginas.unshift(paginaActual - 1);
                        if (paginaActual - 2 > 1) {
                            paginas.unshift(paginaActual - 2);
                        }
                    }

                    if (paginaActual + 1 < $scope.lastPage) {
                        paginas.push(paginaActual + 1);
                        if (paginaActual + 2 < $scope.lastPage) {
                            paginas.push(paginaActual + 2);
                        }
                    }

                    if (paginaActual !== 1) {
                        paginas.unshift(1);
                    }

                    if (paginaActual !== $scope.lastPage) {
                        paginas.push($scope.lastPage);
                    }

                    return paginas;
                }

                function primera() {
                    $scope.selectedChofer = 0;
                }

                function anterior() {
                    if ($scope.selectedChofer === 0 && $scope.currentPage > 1) {
                        retrocederPagina();
                    } else {
                        $scope.selectedChofer--;
                    }
                }

                function siguiente() {
                    if (
                        $scope.selectedChofer < $scope.currentPageChoferes.length - 1
                    ) {
                        $scope.selectedChofer++;
                    } else {
                            avanzarPagina();
                    }
                }

                function retrocederPagina() {
                    if ($scope.currentPage > 1) {
                        $scope.selectPage($scope.currentPage - 1);
                        $scope.selectedChofer = $scope.numPerPage - 1;
                    }
                }

                function avanzarPagina() {
                    if ($scope.currentPage < $scope.lastPage) {
                        $scope.selectPage($scope.currentPage + 1);
                        $scope.selectedChofer = 0;
                    }
                }
            }
        ]
    );
